<id>
File Attachment V3.0 for SP1.3.x
</id>

<version>
3.0i Beta
</version>

<mod info>
Allows the attachment of a file to a post. Filesize, types, and paths all must be edited in the admin center after applying this mod before file attaching will work. If settings are not applied immediately, uers may experience errors when trying to post until you define all the variables for the mod. Directory and URL paths should be without trailing '/'. The directory you create for attachments should be world readable and writeable, also (chmod 666 or 777).
The paperclip.gif file should be placed into your YaBBImages folder or wherever you keep all your YaBB images. The Attachments.pl file should be put into your Sources folder (leave as is, dont chmod to anything), and upload attachments.txt, oldestattach.txt, and maxattachsize.txt to your variables folder and chmod all of them to 666. Make sure you upload everything but the paperclip.gif image in ASCII mode.
Thanks to Dave Baughman and Al for their inspiration.

Read the included readme.txt file for more information and thanks.

History
3.0a
- Fixed missing right curly brackets in Post.pl
- Fixed missing lines in ModifyMessage.pl
- Added Util.pm to local Upload/GCI.pm

3.0b
- Added No Overwrite allowed to the global settings
- Changed radio buttons on modify to pulldown selector.
</mod info>

3.0c
- Added forgotten code to delete an attachment if a post is deleted.

3.0d
- Fixed code to delete an attachment if a post is deleted.
- Made file format backward compatible with version 2.5 and earlier (meaning it would show attachments made by earlier version).

3.0e
- Fixed CGITemp* files not being deleted and still written in the wrong path.

3.0f
- Fixed CGITemp* files not being deleted on modification/re-attach.
  Changed files are Post.pl, ModifyMessage.pl and CGI.pm

3.0g
- Reorganised code major, making it more efficient.
- Added missing temp clear sub in Modify Message.
- Moved att handling and upload routines to Subs.pl

3.0h
- Moved language to separate language packs.

3.0i
- Implemented TheSkiers (vikmars@yahoo.com) fixes and enhancements.
<author>
Ron@Spikecity
</author>

<homepage>
http://www.yabbforum.com
</homepage>

<edit file>
YaBB.pl
</edit file>

<search for>
### Requirements and Errors ###
</search for>

<add before>
push(@INC, "./Modules");

</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'editnews2',"AdminEdit.pl&EditNews2",
</search for>

<add after>
'deleteattachment',"Attachments.pl&DeleteAttachments",
'manageattachments',"Attachments.pl&Attachments",
'manageattachments2',"Attachments.pl&ViewAttachments",
'removeoldattachments',"Attachments.pl&RemoveOldAttachments",
'removebigattachments',"Attachments.pl&RemoveBigAttachments",
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
sub Display {
</search for>

<add after>
	my($attachment,$showattach);
</add after>

<search for>
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $_);
</search for>

<replace>
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb, $msf, $mfn) = split(/[\|]/, $_);
</replace>

<search for>
		# Should we show "last modified by?"
</search for>

<replace>
		# Should we show an attachment file?
			if($mfn && $mfn ne "") {
			if (-e ("$upload_dir/$mfn")) {
			$mfn =~ s~$http_dir~~g;
			$attachment = qq~<font size="1"><a href="$http_dir/$mfn" target="_blank"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle"> $mfn</a></font>~;
				if(($mfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) {
					$showattach = qq~<hr width="100%"><center><img src="$http_dir/$mfn" alt"$mfn" border="0"></center>~;
				} else { 
					$showattach = ''; 
				}
			} else { 
				$attachment = qq~<font size="1"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle"> $mfn $fatxt{'1'}</font>~;
				$showattach = '';
			}
		} else {
			$attachment = '';
			$showattach = '';
		}
		
		# Should we show "last modified by?"
</replace>

<search for>
                <font size="2"><B>$msub</b></font><BR>
</search for>

<replace>
                <font size="2"><b>$msub</b></font> &nbsp;$attachment<br />
</replace>

<search for>
                <td align="right"><font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font></td>
              </tr>
            </table>
</search for>

<add after>
            $showattach
</add after>

<edit file>
Sources/Subs.pl
</edit file>


<search for>
$yymain = "";	# set body start to blank
</search for>

<add after>
$CGITempFile::TMPDIRECTORY = "$upload_dir";
</add after>

<search for>
	if ($ENV{REQUEST_METHOD} eq 'POST')
	{
		read(STDIN, my $input, $ENV{CONTENT_LENGTH});
		split_string(\$input, \%FORM) 
	}
</search for>

<replace>
	if ($ENV{REQUEST_METHOD} eq 'POST') {
		if ($ENV{CONTENT_TYPE} =~ /multipart\/form-data/){
			use Upload::CGI; import Upload::CGI qw(:standard);
			my $query = new CGI;
			my (@keylist) = sort($query->param());
			foreach $key (@keylist) {
				$postsize += length($query->param($key));
				# may be dealing with multiple values; need to join with comma
				$value = join(', ', $query->param($key));
				$FORM{$key} = $value;
			}
			if ($query->param('file')) {
				$filename = $query->param('file');
				$postsize -= length($query->param('file'));
				$tmpfile = $query->tmpFileName($filename);
			}
		} else {
			read(STDIN, my $input, $ENV{CONTENT_LENGTH});
			split_string(\$input, \%FORM) 
		}
	}
</replace>

<search for>
sub get_date {
</search for>

<add before>
sub dirstats {
	use File::Find;
	my ($size, $used_space, $free_space) = 0;
	&find ( sub { $dirsize += -s }, $upload_dir );
	$used_space = int ($dirsize / 1024);
	$spaceleft = ($mydirlimit - $dirsize);
	$kbspaceleft = ($dirlimit - $used_space);
}

sub clear_temp {
	if($filename) {
		close($filename);
	}
	if (-e $tmpfile && $tmpfile ne '')  {
		close($tmpfile);
		unlink $tmpfile || &fatal_error("Error deleting tempfile '$tmpfile': $!\n");
	}
}

sub write_error {
	my $e = $_[0];
	&clear_temp;
	&LoadIMs;	# Load IM's
	$yymain .= qq~
<table border=0 width="80%" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'106'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><br /><font size="2">$e</font><br /><br /></td>
  </tr>
</table>
<center><br /><a href="javascript:history.go(-1)">$txt{'250'}</a></center>
~;
	$yytitle = "$txt{'106'}";
	&template;
	exit;

}

sub upload {
###########################################
##  Spikecity's File Attachment Mod V3.0 ##
###########################################
	if ($FORM{'file'} && $FORM{'w_file'} eq "attachnew") {
		$file = $FORM{'file'};
		$OS = $^O; # operating system name
		if($OS =~ /darwin/i) { $isUNIX = 1; }
		elsif($OS =~ /win/i) { $isWIN = 1; }
		else {$isUNIX = 1;}
		$mylimit = 1024 * $limit;
		$mydirlimit = 1024 * $dirlimit;
		$fixfile = $filename;
		$fixfile =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
		$fixfile =~ s/[#%+,\/:?"<>'|@^!]//g;	#edit in between [ ] to include characters you dont want to allow in filenames (dont put a . there or you wont be able to get any file extensions).
		$fixfile =~ s/ /_/g;			#replaces spaces in filenames with a "_" character.

		if($overwrite == 2 && (-e "$upload_dir/$fixfile")){&fatal_error("$fatxt{'8'}");}
		if(!$overwrite){ # if $overwite = 0 or false, rename file using the checkex sub
			$fixfile = check_existence($upload_dir,$fixfile);
		}
		if ($checkext == 0) { $match = 1; } else {
		foreach $ext (@ext){
			chomp ($ext);
				if (grep /$ext$/i,$fixfile){$match=1; last;}
			}
		}
		if ($match) {
			if ($allowattach == 1 && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) { 
				$upload_okay = 1;
			}
		} else {
			&write_error("$fatxt{'20'} @ext ($fixfile)"); 
		}
		if ($mydirlimit > 0) {
			&dirstats;
		}
		$filesize = $ENV{'CONTENT_LENGTH'} - $postsize;
		$filesizekb = int ($filesize/1024);
		if ($filesize > $mylimit && $mylimit != 0) {
			$filesizediff = $filesizekb - $limit;
			if ($filesizediff == 1) { $sizevar = "$fatxt{'21d'}"; } else { $sizevar = "$fatxt{'21e'}"; }
			&write_error("$fatxt{'21'} $filesizediff $sizevar $fatxt{'21b'}");
		} elsif ($filesize > $spaceleft && $mydirlimit != 0) {	
			$filesizediff = $filesizekb - $kbspaceleft;
			if ($filesizediff == 1) { $sizevar = "$fatxt{'21d'}"; } else { $sizevar = "$fatxt{'21e'}"; }
			&write_error("$fatxt{'22'} $filesizediff $sizevar $fatxt{'22b'}");
		}
		if ($upload_okay == 1) {
			# create a new file on the server using the formatted ( new instance ) filename
			if(open(NEWFILE, ">$upload_dir/$fixfile")){
				if($isWIN){binmode NEWFILE;} # if it's a WIN server, switch to binary mode
				# start reading users HD 1 kb at a time.
				while (read($filename, $buffer, 1024)){ 
					# print each kb to the new file on the server 
					print NEWFILE $buffer; 
				}
				# close the new file on the server and we're done
				close (NEWFILE);
			} else {
				# return the server's error message if the new file could not be created
				&fatal_error("$fatxt{'60'} $upload_dir");
			}
		}
					
		# check if file has actually been uploaded, by checking the file has a size
		if(-s "$upload_dir/$fixfile"){
			$upload_ok = 1;
		} else {
			# delete the file as it has no content
			unlink("$upload_dir/$fixfile");
			&fatal_error("$fatxt{'59'} $fixfile");
		}
		&clear_temp;
	}
###########################################
## /Spikecity's File Attachment Mod V3.0 ##
###########################################
}

sub do_attach {
	my($dowhat,$att,$old_att,$att_thread,$reply,$subject,$name)= @_;
	if($dowhat eq "" || $att eq ""){ return 0; }
	if($dowhat eq "add" && ($att_thread eq "" || $reply eq "")){ return 0; }
	if ($dowhat ne "flush") {
		fopen(AML, "$vardir/attachments.txt");
		my @attachments = <AML>;
		fclose(AML);
		fopen(AML, ">$vardir/attachments.txt");
		foreach (@attachments) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if($amfn ne $att && $amfn ne $old_att) {
				print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
			} 
				elsif (($dowhat eq "rename") && ($amfn eq $old_att)) { $am_buf = $_; }	###(VM)::: KEEP_ENTRY_WITH_OLD_FA
		}
		if(($dowhat eq "add" && $action eq "post2") || ($dowhat eq "add" || $dowhat eq "swap")) {
			print AML qq~$att_thread|$reply|$subject|$name|$currentboard|$filesizekb|$date|$att\n~;
			} elsif ($dowhat eq "rename") {	###(VM)::: RENAME_FILE
				my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$am_buf);
				if (rename("$upload_dir/$old_att","$upload_dir/$att")) {
					print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$att\n~;
					fclose(AML); return(1);
				}
				else {return(-1);}	###/(VM)
			} elsif($dowhat eq "remove") {
			if (-e("$upload_dir/$att")) {
				unlink("$upload_dir/$att");
			}
		}
		if (-e("$upload_dir/$old_att") && ($old_att ne "") && ($dowhat ne "rename")) {
			unlink("$upload_dir/$old_att");	###(VM)::: check modes before removing
		}
		fclose(AML);
	}
	elsif ($dowhat eq "flush" && $att eq "all") {
		opendir (AMD,$upload_dir) || &fatal_error("$fatxt{'19'} $upload_dir!");
			while ($files = readdir(AMD)) {
				if ($files ne "." && $files ne "..") {
					$killfile = "$upload_dir/$files";
					unlink($killfile);
				}
			}
		closedir(AMD);
		fopen(AML, ">$vardir/attachments.txt");
		fclose(AML);
	}
}

###(VM): check if file_name valid

sub check_fname {
	my ($filename) = @_;

	($filename eq "")   and &write_error("$fatxt{'20a'}$fatxt{'20b'}");	### empty

	($filename =~ m,^([A-Za-z0-9\-_.]*)$,) ?
		($filename = $1) :
		(&write_error("$fatxt{'20a'}$fatxt{'20d'}"));	### ASCII only

	($filename =~ m,\.\.,)   and &write_error("$fatxt{'20a'}$fatxt{'20d'}");	### no double ..
	($filename =~ m,^\.,)    and &write_error("$fatxt{'20a'}$fatxt{'20d'}");	### no leading .
	(length($filename) > 30) and &write_error("$fatxt{'20a'}$fatxt{'20c'}");	### too long

	$filename =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;	### ???

	if ($checkext == 0) { $match = 1; } else {
	foreach $ext (@ext){
		chomp ($ext);
			if (grep /$ext$/i,$filename){$match=1; last;}
		}
	}
	if ($match) {
		return($filename);
	} else {
		&write_error("$fatxt{'20'} @ext ($filename)"); 
	}
}

sub check_existence {
	# $dir,$filename,$newnum are the args passed to this sub
	my ($dir,$filename,$newnum) = @_;
	
	my (@file_type, $file_type, $exists, $barename); 

	if(!$newnum){$newnum = "0";} # new num is empty in first call, so set it to 0
	
	# read dir and put all files in an array (list)
	opendir(DIR, "$dir");
	@existing_files =  readdir(DIR);
	closedir(DIR);
	
	# if the filename passed exists, set $exists to true or 1
	foreach(@existing_files){
		if($_ eq $filename){
			$exists = 1;
		}
	}
	
	# if it exists, we need to rename the file being uploaded and then recheck it to 
	# make sure the new name does not exist
	if($exists){
		$newnum++; # increment new number (add 1)

		# get the extension
		@file_type   = split(/\./, $filename); # split the dots and add inbetweens to a list
		# put the first element in the $barename var
		$barename    = $file_type[0]; 
		# we can assume everything after the last . found is the extension
		$file_type   = $file_type[$#file_type]; 
		# $#file_type is the last element (note the pound or hash is used)
		
		# remove all numbers from the end of the $barename
		$barename =~ s/\d+$//ig;
		
		# concatenate a new name using the barename + newnum + extension 
		$filename = $barename . $newnum . '.' . $file_type;
		
		# reset $exists to 0 because the new file name is now being checked
		$exists = 0;
		
		# recall this subroutine
		&check_existence($dir,$filename,$newnum);
	} else {
		# the $filename, whether the first or one hundreth call, now does not exist
		# so return the name to be used
		return ($filename);
	}
}

</add before>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
</search for>

<add after>
	my($filetype_info, $filesize_info);
</add after>

<search for>
	my $extra;
</search for>

<replace>
	my $extra;
	my($filetype_info, $filesize_info, $extensions);
	$extensions = join(" ", @ext);
	$filetype_info = $checkext == 1 ? qq~$fatxt{'2'} $extensions~ : qq~$fatxt{'2'} $fatxt{'4'}~;
	$filesize_info = $limit != 0 ? qq~$fatxt{'3'} $limit $fatxt{'21c'}~ : qq~$fatxt{'3'} $fatxt{'5'}~;
</replace>

<search for>
        </font><BR><BR></td>
      </tr>
</search for>

<replace>
        </font><br /></td>
      </tr>
~;
##########################################
## Spikecity's File Attachment Mod V3.0 ##
## (VM) + rename_attachment             ##
##########################################
if ($allowattach == 1 && ($action eq 'post' || $action eq 'post2' || $action eq 'modify' || $action eq 'modify2') && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
$yymain .= qq~
<tr>
	<td valign="top"><b>$fatxt{'6'}</b></td>
	<td><input type="file" name="file" size="50" />~;
$yymain .= qq~
	</td>
</tr>
<tr>
	<td align="right"></td>
</tr>
~;
if ($action eq 'modify' || $action eq 'modify2') {
#
if($is_preview == 1) {	###(VM)::: IN_PREVIEW!
	$isatt = $old_attname = $FORM{'old_attname'};
	$new_attname = $FORM{'new_attname'};
	$w_file=$FORM{'w_file'};
	$delattcheck = $newattcheck = $oldattcheck = $renattcheck = qq~~;

	if ($w_file eq "attachdel" ) {
		$delattcheck = qq~selected="selected"~; }
	elsif ($w_file eq "attachnew" ) {
		$newattcheck = qq~selected="selected"~; }
	elsif ($w_file eq "attachold" ) {
		$oldattcheck = qq~selected="selected"~; }
	elsif ($w_file eq "attachren" ) {
		$renattcheck = qq~selected="selected"~; }
	} else {$old_attname = $new_attname = $isatt;}

if($isatt ne ""){
	if (!$is_preview)	{
		$oldattcheck = qq~selected="selected"~;
		$newattcheck = qq~~;
	}
$atistxt = qq~$fatxt{'40'}: <a href="$http_dir/$isatt">$isatt</a>~;
$yymain .= qq~
<tr>
	<td valign="top"></td>
	<td><font size="1">
<script language ="JavaScript">
<!--
// ###(VM)::: HIGLIGHT_FILE_NAME
function selChange(seln,x_num,x_name) {
selNum = seln.w_file.selectedIndex;
Isel = seln.w_file.options[selNum].text;
seln.new_attname.value = x_name;
if (selNum == x_num) {
	seln.new_attname.focus();
	seln.new_attname.select();
	}
else {seln.new_attname.value = "";}
}
//-->
</script>
	<select name="w_file" size="1" onChange="selChange(this.form,3,'$new_attname')">
	<option value="attachdel">$fatxt{'6c'}</option>
	<option value="attachnew" $newattcheck>$fatxt{'6b'}</option>
	<option value="attachold" $oldattcheck>$fatxt{'6a'}</option>
	<option value="attachren" $renattcheck>$fatxt{'6d'}</option>
	</select>&nbsp;<input name="old_attname" type="hidden" value="$old_attname"><input name="new_attname" type="text" value="$new_attname" size="40"><input type="button" value="$txt{'278'}" onClick="javascript:this.form.new_attname.value='$old_attname'; this.form.new_attname.select()"><BR>$atistxt &nbsp;</font></td>
</tr>~;
	} else {	###(VM)::: NEW_ATTACHNENT, JUST_BROWSE!
		$yymain .= qq~<input type="hidden" name="w_file" value="attachnew">~;
	}
} else {	###(VM)::: NEW_ATTACHNENT, JUST_BROWSE! ###CHK!! USED_TWICE_BUT_WORKS!
		$yymain .= qq~<input type="hidden" name="w_file" value="attachnew">~;
	}
if( ($is_preview == 1) && $FORM{'file'} ) {
$yymain .= qq~
<tr>
	<td align="right"></td>
	<td><font size="1">$fatxt{'7'}</font></td>
</tr>
~;
}
}
##########################################
##/Spikecity's File Attachment Mod V3.0 ##
##########################################
$yymain .= qq~
</replace>

<search for>
<form action="$cgi;action=$destination" method="post" name="postmodify" onSubmit="return submitproc()">
</search for>

<replace>
<form action="$cgi;action=$destination" method="post" name="postmodify" enctype="multipart/form-data" onsubmit="return submitproc()">
</replace>

<search for>
sub Preview {
</search for>

<replace>
sub Preview {
	&clear_temp;
</replace>

<search for>
	# If no thread specified, this is a new thread.
</search for>

<add before>
	if ($FORM{'file'} ne "" && $FORM{'w_file'} eq "attachnew") { &upload; }
</add before>

<search for>
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("210 $txt{'106'}: $txt{'23'} $currentboard.txt");
</search for>

<replace>
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &write_error("210 $txt{'106'}: $txt{'23'} $currentboard.txt");
</replace>

<search for>
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
</search for>

<replace>
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &write_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
</replace>

<search for>
		fopen(FILE, ">$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|\n~;
		fclose(FILE);
		$mreplies = 0;
</search for>

<replace>
		fopen(FILE, ">$datadir/$newthreadid.txt") || &write_error("$txt{'23'} $newthreadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns||||$fixfile\n~;
		fclose(FILE);
		$mreplies = 0;
		if ($fixfile) {
			&do_attach("add",$fixfile,"",$newthreadid,"0",$subject,$username);
		}
</replace>

<search for>
		fopen(FILE, ">>$datadir/$threadid.txt") || &fatal_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|\n~;
		fclose(FILE);
</search for>

<replace>
		fopen(FILE, ">>$datadir/$threadid.txt") || &write_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns||||$fixfile\n~;
		fclose(FILE);
		if ($fixfile) {
			&do_attach("add",$fixfile,"",$mnum,$mreplies,$subject,$username);
		}
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
sub ModifyMessage {
</search for>

<add after>
	my( $msf, $mfn);
</add after>

<search for>
	$message =~ s/<br>/\n/ig;
</search for>

<add after>
	$isatt = $mfn;
	chomp $isatt;
</add after>

<search for>
	($sub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip,  $message, $mns, $mlm, $mlmb) = split(/\|/,$messages[$postid]);
</search for>

<replace>
	($sub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip,  $message, $mns, $mlm, $mlmb, $msf, $mfn) = split(/\|/,$messages[$postid]);
</replace>

<search for>
	my( $deletepost, $threadid, $postid, @messages, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, @threads, $tmpa, $tmpb, $tnum2, $tdate2, $newlastposttime, $newlastposter, $lastpostid, $views, $name, $email, $subject, $message, $ns, $postkilled, $threadkilled );
</search for>

<replace>
	my( $deletepost, $threadid, $postid, @messages, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, @threads, $tmpa, $tmpb, $tnum2, $tdate2, $newlastposttime, $newlastposter, $lastpostid, $views, $name, $email, $subject, $message, $ns, $postkilled, $threadkilled );
	if ($FORM{'file'} ne "" && $FORM{'w_file'} eq "attachnew") { &upload; }
</replace>

<search for>
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $messages[$postid]);
</search for>

<replace>
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $messages[$postid]);
</replace>

<search for>
			$threadkilled = 1;
</search for>

<add after>
			fopen(FILE, "$datadir/$tnum.txt");
			my @amthreadcheck = <FILE>;
			fclose(FILE);
			chomp $amthreadcheck[0];
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $amthreadcheck[0] );	
			&do_attach("remove",$mfn);
</add after>

<search for>
			$messages[$postid] = '';
</search for>

<add before>
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $messages[$postid] );
			&do_attach("remove",$mfn);
</add before>

<search for>
				$_ = $messages[1];
				chomp;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $_ );
</search for>

<replace>
				$_ = $messages[1];
				chomp;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $_ );
</replace>

<search for>
				$_ = $messages[$lastpostid];
				chomp;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $_ );
</search for>

<replace>
				$_ = $messages[$lastpostid];
				chomp;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $_ );
</replace>

<search for>
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username\n~;
</search for>

<replace>
		if ($FORM{'w_file'} eq "attachnew" && $fixfile) {
			$is_attached = $fixfile;
			&do_attach("swap",$fixfile,$mfn,$threadid,$treplies,$subject,$username);
		} elsif ($FORM{'w_file'} eq "attachold") {
			$is_attached = $mfn;
			&clear_temp;
		} elsif ($FORM{'w_file'} eq "attachnew" && !$fixfile) {
			$is_attached = $mfn;
		} elsif ($FORM{'w_file'} eq "attachdel" && -e("$upload_dir/$mfn")) {
			$is_attached = "";
			&do_attach("remove",$mfn);
		} elsif ($FORM{'w_file'} eq "attachren") {	###(VM)::: RENAME_ATTACH
			$is_attached = $mfn; $new_attname = $FORM{'new_attname'};
			if ($new_attname ne $mfn) {
				$new_attname = check_fname($new_attname);
				$new_attname = check_existence($upload_dir,$new_attname);
				&do_attach("rename",$new_attname,$mfn,$threadid,$treplies,$subject,$username) || &fatal_error("$fatxt{'6e'}: '$mfn' to '$new_attname'");	### NEED_TO_CHECK_RETURN!!
				$is_attached = "$new_attname";
			}	###/(VM)
		} elsif ($FORM{'w_file'} eq "attachdel" && !-e("$upload_dir/$mfn")) {
			$is_attached = "";
		} else {
			$is_attached = $mfn;
		}
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username||$is_attached\n~;
		print FILE @messages;
		fclose(FILE);
</replace>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
	$movedpost = join("|", @movedthread);
</search for>

<add before>
	###(VM)###################################
	## File Attachment Mod V3.0 (Eddy's fix)##
	##########################################
	  #fix attachment info
	  fopen(AMP, "$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
	  my @attachinfo = <AMP>; 
	  my $attachchg = 0;
	  fclose(AMP);
	  foreach (@attachinfo) {
		    my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);			 
		    if ($amthreadid eq $thread) { 
				$_ = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$toboard|$amkb|$amdate |$amfn~;
				$attachchg = 1;
		    }
	  }	 
	  if ($attachchg) {
		# only rewrite if it actually changed
		fopen(AMP, ">$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP @attachinfo;
		fclose(AMP);
	  }	 

	  #remove attachment from old post
	  $movedthread[12] = "";
	  $movedthread[13] = "";
	###(VM)###################################
	## /File Attachment Mod V3.0 (Eddy's fix)#
	##########################################
</add before>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
		unlink("$boardsdir/$curboard.ctb");
</search for>

<add after>
		fopen(AMV, "$vardir/attachments.txt");
		my @attachments = <AMV>;
		fclose(AMV);
		fopen(AMV, ">$vardir/attachments.txt");
			foreach (@attachments) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if($amcurrentboard ne $curboard) {
				print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
			} else {
				if (-e("$upload_dir/$amfn")) {
					unlink("$upload_dir/$amfn");
				}
			}
		}
		fclose(AMV);
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
			unlink("$boardsdir/$curboard.dat");
</search for>

<add after>
			fopen(AMV, "$vardir/attachments.txt");
			my @attachments = <AMV>;
			fclose(AMV);
			fopen(AMV, ">$vardir/attachments.txt");
				foreach (@attachments) {
				chomp $_;
				my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
				if($amcurrentboard ne $curboard) {
					print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
				} else {
					if (-e("$upload_dir/$amfn")) {
						unlink("$upload_dir/$amfn");
					}
				}
			}
			fclose(AMV);
</add after>

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					unlink("$datadir/$num.data");
</search for>

<add after>
					fopen(AMV, "$vardir/attachments.txt");
					my @attachments = <AMV>;
					fclose(AMV);
					fopen(AMV, ">$vardir/attachments.txt");
						foreach (@attachments) {
						chomp $_;
						my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
						if($amthreadid ne $num) {
							print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
						} else {
							if (-e("$upload_dir/$amfn")) {
								unlink("$upload_dir/$amfn");
							}
						}
						
					}
					fclose(AMV);
</add after>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.data");
</search for>

<add after>
	fopen(AMV, "$vardir/attachments.txt");
	my @attachments = <AMV>;
	fclose(AMV);
	fopen(AMV, ">$vardir/attachments.txt");
	foreach (@attachments) {
		chomp $_;
		my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
		if($amthreadid ne $thread) {
			print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		} else {
			if (-e("$upload_dir/$amfn")) {
				unlink("$upload_dir/$amfn");
			}
		}
	}
	fclose(AMV);
</add after>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        <td bgcolor="$color{'catbg'}" height="19" class="catbg"><img src="$imagesdir/board.gif" alt="" border="0"> <font size="2"><b>$txt{'501'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="1">
</search for>

<add after>
        - <a href="$cgi;action=manageattachments">$fatxt{'9'}</a><br>
</add after>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub ModifySettings {
</search for>

<add before>
## /START section added in File Attachments v3.0 to auto-config paths needed for mod
sub AttachDir {
	&is_admin;
	my $findme = 'attachments'; # Set this equal to the name of your attachments directory.
	if((-d $_) && ($_ eq "$findme")) {
		$upload_dir = "$File::Find::dir/$_";
	}
}
## /END File Attachment auto-config paths section

</add before>

<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($checkextcheck, $extlist, $extitem, $amdisplaypicscheck, $allowattachcheck, $allowguestattachcheck, $st0, $st1, $st2, $tmpax0, $tmpax1);

## /START section added in File Attachments v2.4 to auto-config paths needed for mod
	if ((!$upload_dir || !$http_dir) && $ENV{'DOCUMENT_ROOT'} && $INFO{'famod'} ne "autoconfig") {
		$attachment_status = qq~
		  </tr><tr>
		    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><a href="$cgi;action=modsettings;famod=autoconfig"><font size="2">Click to attempt to auto-configure mod</font></a></td>
		  ~;
	}
		
	if(!$upload_dir && $ENV{'DOCUMENT_ROOT'} && $INFO{'famod'} eq "autoconfig") {
		my $toplevel = "$ENV{'DOCUMENT_ROOT'}";
		if($http_dir) {
			my $upload_dir_temp = $http_dir;
			$upload_dir_temp =~ s~http://[\w|\.]+/?(\S*)~$1~is;
			$upload_dir = "$toplevel/$upload_dir_temp";
			$upload_dir =~ s~\/\/~\/~g;
			$attachment_status = qq~
				  </tr><tr>
				    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory set to: $upload_dir.\\nPlease save your settings.");</script></font></td>
				  ~;			
		} else {
			eval { use File::Find; };
			unless($@) {
				&find(\&AttachDir, $toplevel);
				if($upload_dir && !$http_dir) {
					my $http_dir_temp = $boardurl;
					$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
					my $http_dir_temp2 = $upload_dir;
					$http_dir_temp2 =~ s~$toplevel/?(\S*)~$1~is;
					$http_dir = "$http_dir_temp/$http_dir_temp2";
					$upload_dir =~ s~\/\/~\/~g;
					$attachment_status = qq~
						  </tr><tr>
						    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory set to: $upload_dir.\\nAttachments URL set to: $http_dir.\\nPlease save your settings.");</script></font></td>
						  ~;			
				}
				if(!$upload_dir && (-e "$toplevel/yabbattach")) {
					$upload_dir = "$toplevel/yabbattach";
					my $http_dir_temp = $boardurl;
					$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
					$http_dir = "$http_dir_temp/yabbattach";
					$upload_dir =~ s~\/\/~\/~g;
					$attachment_status = qq~
						  </tr><tr>
						    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory set to: $upload_dir.\\nAttachments URL found: $http_dir.\\nPlease save your settings.");</script></font></td>
						  ~;	
				} elsif(!$upload_dir && (!-e "$toplevel/yabbattach")) { 
					mkdir("$toplevel/yabbattach", 0766) || &fatal_error("Could not create $toplevel/yabbattach for attachments directory.");
					my $http_dir_temp = $boardurl;
					$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
					$http_dir = "$http_dir_temp/yabbattach";		
					$upload_dir = "$toplevel/yabbattach";
					$upload_dir =~ s~\/\/~\/~g;
					$attachment_status = qq~
						  </tr><tr>
						    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments directory created and set to: $upload_dir.\\nAttachments URL set to: $http_dir.\\nPlease save your settings.");</script></font></td>
						  ~;
				}
			}
		}
	}
	if(!$http_dir && $ENV{'DOCUMENT_ROOT'} && $upload_dir && $INFO{'famod'} eq "autoconfig") {
		my $toplevel = "$ENV{'DOCUMENT_ROOT'}";
		my $http_dir_temp = $boardurl;
		$http_dir_temp =~ s~(http://[\w|\.]+)/?.*~$1~is;
		my $http_dir_temp2 = $upload_dir;
		$http_dir_temp2 =~ s~$toplevel/?(\.*)~$1~is;
		$http_dir = "$http_dir_temp/$http_dir_temp2";
		$attachment_status = qq~
			  </tr><tr>
			    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center"><font size="2"><script language="javascript">alert("Attachments URL set to: $http_dir.\\nPlease save your settings.");</script></font></td>
			  ~;
	}
	$upload_dir =~ s~\/\/~\/~g;
## /END File Attachment auto-config paths section
</add after>

<search for>
	# figure out what to print
</search for>

<add after>
	$extlist = join(" ", @ext);
	$extlist =~ s~\s+$~~;
	$extlist =~ s~^\s+~~;
	if ($checkext == 1) { $checkextcheck = ' checked="checked" '; }
	if ($amdisplaypics == 1) { $amdisplaypicscheck = ' checked="checked" '; }
	if ($allowattach == 1) { $allowattachcheck = ' checked="checked" '; }
	if ($allowguestattach == 1) { $allowguestattachcheck = ' checked="checked" '; }
	if ($overwrite == 0) { $tmpax0 = ' selected="selected" '; } elsif ($overwrite == 1) { $tmpax1 = ' selected="selected" '; } elsif ($overwrite == 2) { $tmpax2 = ' selected="selected" '; }
</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'392'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_EX" size="5" value="$LOCK_EX"></td>
</search for>

<add before>
  $attachment_status
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="upload_dir" size="35" value="$upload_dir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="http_dir" size="35" value="$http_dir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'53'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
	<select name="overwrite" size="1">
	<option value="0"$tmpax0>$fatxt{'54r'}</option>
	<option value="1"$tmpax1>$fatxt{'54o'}</option>
	<option value="2"$tmpax2>$fatxt{'54n'}</option>
	</select>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="limit" size="5" value="$limit"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="dirlimit" size="5" value="$dirlimit"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'14'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="extensions" size="35" value="$extlist"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'15'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="checkext" value="1"$checkextcheck></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'16'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="amdisplaypics" value="1"$amdisplaypicscheck></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'17'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="allowattach" value="1"$allowattachcheck></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fatxt{'18'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="allowguestattach" value="1"$allowguestattachcheck></td>
  </tr><tr>
    <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <hr size="1" width="100%" color="$color{'windowbg3'}" class="windowbg3"></td>
</add before>

<search for>
	# If empty fields are submitted, set them to default-values to save yabb from crashing
</search for>

<add after>
	$overwrite = $FORM{'overwrite'} || 0;
	$upload_dir = $FORM{'upload_dir'};
	$upload_dir =~ s~\s+$~~;
	$http_dir = $FORM{'http_dir'};
	$http_dir =~ s~\s+$~~;
	$extensions = $FORM{'extensions'};
	$extensions =~ s~\s+$~~;
	$limit = $FORM{'limit'} || 0;
	$dirlimit = $FORM{'dirlimit'} || 0;
	$checkext = $FORM{'checkext'} || 0;
	$amdisplaypics = $FORM{'amdisplaypics'} || 0;
	$allowattach = $FORM{'allowattach'} || 0;
	$allowguestattach = $FORM{'allowguestattach'} || 0;
</add after>

<search for>
########## Feature Settings ##########
</search for>

<replace>
########## File Attachment Settings ##########

\$http_dir = "$http_dir";  				# The full url to the directory where your attachments are to be stored (without trailing '/' )
\$upload_dir = "$upload_dir";  				# The absolute path to the directory where your attachments are to be stored (without trailing '/' )
\$limit = $limit;  					# Set to the maximum number of kilobytes an attachment can be. Set to 0 to disable the file size check.
\$dirlimit = $dirlimit;  				# Set to the maximum number of kilobytes the attachment directory can hold. Set to 0 to disable the directory size check.
\$overwrite = $overwrite;				# Set to 0 to auto rename attachments if they exist or 1 to overwrite them or 2 to give an error if a file exists on the server.
\@ext = qw($extensions);  				# The allowed file extensions for file attachements. Variable should be set in the form of "jpg bmp gif" and so on.
\$checkext = $checkext;  				# Set to 1 to enable file extension checking, set to 0 to allow all file types to be uploaded
\$amdisplaypics = $amdisplaypics;  			# Set to 1 to display attached pictures in posts, set to 0 to only show a link to them.
\$allowattach = $allowattach;				# Set to 1 to allow file attaching, set to 0 to disable file attaching.
\$allowguestattach = $allowguestattach;			# Set to 1 to allow guests to upload attachments, 0 to disable guest attachment uploading.

########## Feature Settings ##########
</replace>